local _G = _G

local EnvCache = setmetatable({}, { __mode = "kv"})
ShinyEnv = setmetatable({ 
							_G = _G,
							rawget = rawget,
						},
						{ 
							__index = function(t, k) 
								if (EnvCache[k]) then
									return EnvCache[k]
								end

								local v = rawget(t[k])
								if (v) then
									EnvCache[k] = v
									return v
								end
							end
						})

